package simulation;

class Event implements Comparable<Event> {
	// Our only data members, we don't want anyone to tamper with these
	private double eventTime;
	private int eventType;

	// Constructor, creates an event of a certain type that should be put in the
	// event list at a certain time. Throws if type is out of bounds.
	Event(int type, double eventTimeStamp) throws IllegalArgumentException {
		// if (type > 3 || type < 1)
		// 	throw new IllegalArgumentException("Event type must be one of ARRIVAL, READY or MEASURE");

		eventType = type;
		eventTime = eventTimeStamp;
	}

	// Setters and getters for the private variables instead of having them public
	public double getEventTime() {
		return eventTime;
	}
	public int getEventType() {
		return eventType;
	}

	// This is the custom comparator that PriorityQueue uses to sort the events
	@Override
	public int compareTo(Event e) {
		return Double.compare(eventTime, e.eventTime);
	}
}
