package simulation;

class State extends GlobalSimulation {
	// public int numberInQueue = 0, accumulated = 0, noMeasurements = 0;
	private EventList eventList = null;

	State(EventList eventList) {
		this.eventList = eventList;
	}

	// Dispatches the events to the right handler with a java 20 switch statement
	public void TreatEvent(Event event) {
		switch (event.getEventType()) {
			// case ARRIVAL -> arrival();
			// case SERVE -> serve();
			case MEASURE -> measure();
			case NEW_ARRIVAL -> arrival_A();
			case JOB_A -> handle_A();
			case JOB_B -> handle_B();
		}
		// System.out.println(String.format("Event type: %d, Customers: %d, Time: %.1f",
		// event.getEventType(), numberInQueue, event.getEventTime()));
	}

	private int queue_a, queue_b, measure_amount, accum_a, accum_b;

	public void summary() {
		System.out.println(String.format("Mean number of customers in queue A: %.2f", (double) accum_a / measure_amount));
		System.out.println(String.format("Mean number of customers in queue B: %.2f", (double) accum_b / measure_amount));
		System.out.println(String.format("Total amount of measurements: %d", measure_amount));
	}

	// Helper to generate a random number with certain statistical properties
	private static double generateMean(double mean) {
		return 2 * mean * rand.nextDouble();
	}

	// private void arrival() {
	// 	if (numberInQueue == 0)
	// 		eventList.insertEvent(new Event(SERVE, time + generateMean(1)));
	// 	eventList.insertEvent(new Event(ARRIVAL, time + generateMean(2)));
	// 	numberInQueue++;
	// }

	private void arrival_A() {
		queue_a++;
		eventList.insertEvent(new Event(NEW_ARRIVAL, time + 1000.0/60.0));
		eventList.insertEvent(new Event(JOB_A, time + 2));
	}

	private void handle_A() {
		queue_a--;
		queue_b++;
		eventList.insertPriorityEvent(new Event(JOB_B, time + 4));
	}
	
	private void handle_B() {
		queue_b--;
	}

	// private void serve() {
	// 	// numberInQueue--;
	// 	// if (numberInQueue > 0)
	// 	// 	eventList.insertEvent(new Event(SERVE, time + generateMean(1)));
	// }

	private void measure() {
		accum_a += queue_a;
		accum_b += queue_b;
		measure_amount++;
		eventList.insertEvent(new Event(MEASURE, time + 100));
	}
}